<?php
//basic functions
function myLog($string): void {
    $log = $_GET['log'] ?? $log ?? 'false';
    if ($log == "true") {
        echo "$string<br>";
    }
}
function saveLog($string): void {
    $date = new DateTime();
    $timezone = new DateTimeZone('Asia/Kolkata');
    $date->setTimezone($timezone);
    $today = $date->format('Y-m-d-H');
    $file_name = "log/$today.txt";
    file_put_contents($file_name, "\n".$string, FILE_APPEND);
}
function testLog($string): void {
    $date = new DateTime();
    $timezone = new DateTimeZone('Asia/Kolkata');
    $date->setTimezone($timezone);
    $file_name = "log/test.txt";
    file_put_contents($file_name, "\n".$string, FILE_APPEND);
}
function generateRandomString($length = 64): string {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}
function genOTP(): string {
    $characters = '0123456789';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < 6; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}
function runSql($sqlQuery) {
    global $conn;
    myLog("SQL Query: $sqlQuery");
    $result = $conn->query($sqlQuery);
    if ($result) {
        return $result;
    } else {
        error_log("SQL Error: ".$conn->error . " - Query: $sqlQuery");
        return false;
    }
}

//Notification function by Nikunj Paradva
function sendNotification($title = "", $body = "", $customData = [],$sender = ""){

    //custom lines
    $save = runSql("INSERT INTO `PushNotifications` (`title`, `body`, `receiver`, `info`) VALUES ('$title', '$body', '$sender', '".json_encode($customData)."');");
    if ($save === TRUE) {
        myLog("Notification saved in database");
    }
    saveLog("sendNotification: " . $title . " " . $body . " " . json_encode($customData) . " " . json_encode($sender));

    ini_set("allow_url_fopen", "On");
    $data;
    $customData['title'] = $title;
    $customData['body'] = $body;
    if(count($customData)>0){
        $data =
            [
                "to" => $sender,
                "data" => $customData
            ];

    }else{
        $data =
            [
                "to" => $sender,
                "notification" => [
                    "body" => $body,
                    "title" => $title,
                ]
            ];
    }

    $options = array(
        'http' => array(
            'method'  => 'POST',
            'content' => json_encode( $data ),
            'header'=>  "Content-Type: application/json\r\n" .
                "Accept: application/json\r\n" .
                "Authorization:key=AAAAS5aubmI:APA91bGkqpn4l2S1xThsuz909Qrij5z1VWfkZK8mDz7y5h7adj7PKnut28-dUPyM5iWXdUsh6iWmcjw1yrcotfYC8Aih3KxSbjREo0qpn_lRwDdfKHiS1UJ8i9r5JVKyKbBgjTHNnQLR"
        )
    );

    $context  = stream_context_create( $options );
    saveLog(file_get_contents( "https://fcm.googleapis.com/fcm/send", false, $context ));
    return true;
}
function sendToAll($title = "", $body = "", $customData = []):bool {
    $allSuccess = true;
    $authIds = runSql("SELECT authid, firebase_token FROM AuthIds");
    if (mysqli_num_rows($authIds) > 0) {
        while($row = $authIds->fetch_assoc()) {
            saveLog("sendToAll authId: " . $row['authid']);
            $allSuccess = sendNotification($title, $body, $customData = [],$row['firebase_token']);
            myLog("Notification sent to ".$row['authid']." with title '".$title."' and body '".$body."' and token ".$row['firebase_token']);
        }
    } else {
        $status = "fail";
        myLog("No auth IDs found");
        saveLog("No auth IDs found ");
        $message = "Could not send notifications";
    }
    return $allSuccess;
}
//To Remove
function db_document_get($location, $id) {
    $command = 'get';
    $username = "idzo";
    $authId = "8QVfvX5AnOzNgNrRxJXCoklMRZKO6ao2XPLx2Tc7Re03LonGL6N19rObhR86hddd";
    $type = "document";
    $platform = "web";
    $response = array();
    include 'index1.php';
    return $response;
}
function db_document_add($location, $id, $values) {
    $command = "add";
    $username = "idzo";
    $authId = "8QVfvX5AnOzNgNrRxJXCoklMRZKO6ao2XPLx2Tc7Re03LonGL6N19rObhR86hddd";
    $type = "document";
    $platform = "web";
    $response = array();
    include 'index1.php';
    return $response;
}
function db_document_update($location, $id, $values) {
    $command = "update";
    $username = "idzo";
    $authId = "8QVfvX5AnOzNgNrRxJXCoklMRZKO6ao2XPLx2Tc7Re03LonGL6N19rObhR86hddd";
    $type = "document";
    $platform = "web";
    $response = array();
    include 'index1.php';
    return $response;
}
function db_document_increment($location, $field, $value, $id) {
    $command = "increment";
    $username = "idzo";
    $authId = "8QVfvX5AnOzNgNrRxJXCoklMRZKO6ao2XPLx2Tc7Re03LonGL6N19rObhR86hddd";
    $type = "document";
    $platform = "web";
    $response = array();
    include 'index1.php';
    return $response;
}
function db_document_delete($location, $id) {
    $command = "delete";
    $username = "idzo";
    $authId = "8QVfvX5AnOzNgNrRxJXCoklMRZKO6ao2XPLx2Tc7Re03LonGL6N19rObhR86hddd";
    $type = "document";
    $platform = "web";
    $response = array();
    include 'index1.php';
    return $response;
}
function db_collection($command, $location, $where, $whereValue) {
    $username = "idzo";
    $authId = "8QVfvX5AnOzNgNrRxJXCoklMRZKO6ao2XPLx2Tc7Re03LonGL6N19rObhR86hddd";
    $type = "collection";
    $platform = "web";
    $response = array();
    include 'index1.php';
    return $response;
}
myLog("Functions loaded");